"use strict";var e=require("http-status"),t=require("winston"),r=require("joi"),s=require("@aws-sdk/lib-dynamodb"),a=require("@aws-sdk/client-dynamodb"),n=require("@aws-sdk/client-sqs"),o=require("@aws-sdk/client-cognito-identity-provider"),d=require("@middy/core"),i=require("@middy/event-normalizer"),u=require("@middy/http-event-normalizer"),m=require("@middy/http-json-body-parser"),l=require("crypto");function c(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(r){if("default"!==r){var s=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,s.get?s:{enumerable:!0,get:function(){return e[r]}})}})),t.default=e,Object.freeze(t)}var S=c(r);class g extends Error{constructor(e,t){super(),this.name="HttpError",this.statusCode=500,this.statusCode=t,"string"==typeof e&&(this.message=e),e instanceof Error&&(this.message=e.message)}}class f extends Error{constructor(e,t,r){super(),this.name="ServiceError",this.code=500,this.statusCode=500,this.code=t||500,this.statusCode=r||500,"string"==typeof e&&(this.message=e),e instanceof Error&&(this.message=e.message)}}class p extends g{constructor(t){super(t||e[`${e.BAD_REQUEST}_MESSAGE`],e.BAD_REQUEST),this.name="BadRequestError"}}function C(e){const{error:t,value:r}=e.validate(process.env,{abortEarly:!1,allowUnknown:!0});if(t)throw console.warn(`Configuration is invalid. Detail: ${t}`),new f(`Configuration validation failed. ${t.message}`);return r}const E=S.object({AWS_EXECUTION_ENV:S.string().required(),AWS_LAMBDA_FUNCTION_NAME:S.string().required(),AWS_LAMBDA_FUNCTION_MEMORY_SIZE:S.string().required(),AWS_LAMBDA_FUNCTION_VERSION:S.string().required(),AWS_REGION:S.string().required(),LOGGING_ENABLED:S.boolean().default(!0),LOGGING_LEVEL:S.string().allow("debug","info","warn","error").default("info")}),h=C(E),v={validateConfig:C},{combine:y,json:w,timestamp:N}=t.format,I={format:y(N(),w()),level:h.LOGGING_LEVEL,silent:!h.LOGGING_ENABLED,transports:[new t.transports.Console]},b=t.createLogger(I);b.debug("Logger::creating new Logger");const D={defaultMessage:"Unhandled error",defaultStatusCode:500},O=e=>{const t={...D,...e};return{onError:e=>{if(void 0!==e.response)return;if(!e.error)return;const{error:r}=e;(e=>e instanceof g)(r)?(b.error(`middleware::http-error-handler::HttpError::${r}`,r),e.response={statusCode:r.statusCode??t.defaultStatusCode,body:JSON.stringify({name:r.name,message:r.message??t.defaultMessage,code:r.statusCode??t.defaultStatusCode,statusCode:r.statusCode??t.defaultStatusCode})}):(e=>e instanceof f)(r)?(b.error(`middleware::http-error-handler::ServiceError::${r}`,r),e.response={statusCode:r.statusCode??t.defaultStatusCode,body:JSON.stringify({name:r.name,message:r.message||t.defaultMessage,code:r.code||t.defaultStatusCode,statusCode:r.statusCode||t.defaultStatusCode})}):(b.error(`middleware::http-error-handler::Error::${r}`,r),e.response={statusCode:t.defaultStatusCode??500,body:JSON.stringify({name:r.name,message:r.message??t.defaultMessage,code:t.defaultStatusCode,statusCode:t.defaultStatusCode})})}}},_=()=>({before:e=>{b.defaultMeta={requestId:e.context.awsRequestId}}}),x={abortEarly:!1,allowUnknown:!0},A=e=>({before:t=>{if(b.debug("middleware::validator::before"),e.eventSchema){const{error:r,value:s}=((e,t)=>e.validate(t,x))(e.eventSchema,t.event);if(r)throw b.error(`middleware::validator::error::${r}`),new p(r.message);t.event={...t.event,...s}}}}),M={region:h.AWS_REGION},L={convertEmptyValues:!1,removeUndefinedValues:!0,convertClassInstanceToMap:!0},U={wrapNumbers:!1},q={marshallOptions:L,unmarshallOptions:U};b.debug("DynamoService::creating new DynamoDBDocumentClient",{data:{dynamoDbClientConfig:M,marshallOptions:L,unmarshallOptions:U}});const G=s.DynamoDBDocumentClient.from(new a.DynamoDBClient(M),q),B={batchWriteItems:e=>G.send(new s.BatchWriteCommand(e)),deleteItem:e=>G.send(new s.DeleteCommand(e)),getItem:e=>G.send(new s.GetCommand(e)),putItem:e=>G.send(new s.PutCommand(e)),queryItems:e=>G.send(new s.QueryCommand(e)),scanItems:e=>G.send(new s.ScanCommand(e)),updateItem:e=>G.send(new s.UpdateCommand(e))},T={region:h.AWS_LAMBDA_FUNCTION_VERSION};b.debug("SQSService::creating new SQSClient",{data:{clientConfig:T}});const F=new n.SQSClient(T),R={sendMessage:e=>F.send(new n.SendMessageCommand(e))},W={send:async(e,t)=>{await R.sendMessage({QueueUrl:t,MessageBody:JSON.stringify({data:e.templateData,destinations:e.destinations,template:e.templateName})})}},j={region:h.AWS_REGION},Q=new o.CognitoIdentityProviderClient(j),$={adminDisableUser:e=>Q.send(new o.AdminDisableUserCommand(e)),adminSetUserPassword:e=>Q.send(new o.AdminSetUserPasswordCommand(e)),listUsers:e=>Q.send(new o.ListUsersCommand(e))},P={generate:(e=16)=>{let t=e;(e<1||e>128)&&(t=16);const r=Math.ceil(t/2);return l.randomBytes(r).toString("hex").substring(0,t)},ID_LENGTH_DEFAULT:16,ID_LENGTH_MAXIMUM:128,ID_LENGTH_MINIMUM:1};exports.BadRequestError=p,exports.CognitoIdentityProviderService=$,exports.ConfigService=v,exports.DynamoService=B,exports.EmailService=W,exports.ForbiddenError=class extends g{constructor(t){super(t||e[`${e.FORBIDDEN}_MESSAGE`],e.FORBIDDEN),this.name="ForbiddenError"}},exports.HttpError=g,exports.ID=P,exports.Logger=b,exports.NotFoundError=class extends g{constructor(t){super(t||e[`${e.NOT_FOUND}_MESSAGE`],e.NOT_FOUND),this.name="NotFoundError"}},exports.SQSService=R,exports.ServiceError=f,exports.baseConfigSchema=E,exports.baseConfigValues=h,exports.httpErrorHandler=O,exports.loggerInitializer=_,exports.middyfyAPIGateway=e=>d(e.handler).use(_()).use(u()).use(m()).use(A({eventSchema:e.eventSchema})).use(O({defaultMessage:e.defaultErrorMessage,defaultStatusCode:e.defaultErrorStatusCode})),exports.middyfyLambda=e=>d(e.handler).use(_()).use(A({eventSchema:e.eventSchema})),exports.middyfySNS=e=>d(e.handler).use(_()).use(i()).use(A({eventSchema:e.eventSchema})),exports.middyfySQS=e=>d(e.handler).use(_()).use(i()).use(A({eventSchema:e.eventSchema})),exports.middyfyScheduled=e=>d(e.handler).use(_()).use(A({eventSchema:e.eventSchema})),exports.validator=A;
//# sourceMappingURL=index.js.map
